//
//  AppDelegate.m
//  PDFMerge
//
//  Created by Debenu Pty Ltd on 9/18/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "AppDelegate.h"
#import "Controller.h"

@implementation AppDelegate
@synthesize window;

- (void)dealloc
{
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    
}

- (IBAction)merge:(id)sender
{
    if( [_arrayController.arrangedObjects count] < 2 ) {
        
        NSAlert* alert = [NSAlert alertWithMessageText:@"Please add one more file."
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@"Merge function requires 2 files or more"];
        
        [alert runModal];
        return;
    }
    
    NSArray* files = [_arrayController arrangedObjects];
    NSString* directoryPath = [[files lastObject] stringByDeletingLastPathComponent];
    
    Controller* mergeController = [[[Controller alloc] init] autorelease];
    NSArray* sourceFiles = [_arrayController arrangedObjects];
    
    NSSavePanel* savePanel = [NSSavePanel savePanel];
    [savePanel setNameFieldStringValue:@"merged_file"];
    [savePanel setDirectoryURL:[NSURL fileURLWithPath:directoryPath]];
    [savePanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    
    [NSApp beginSheet:savePanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:savePanel];
    
    [NSApp endSheet:savePanel];
    [savePanel orderOut:self];
    
    if( ret != NSFileHandlingPanelOKButton )
        return;
    
    NSString* toPath = [[savePanel URL] path];
    
    NSError* error = nil;
    
    if( ![mergeController mergeWithFiles:sourceFiles to:toPath error:&error] ) {
        
        NSAlert* alert = [NSAlert alertWithMessageText:@"Error!"
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@"%@", [error localizedDescription]];
        
        [alert runModal];
        return;
    }
    
    [[NSWorkspace sharedWorkspace] openFile:toPath];
}

- (IBAction)add:(id)sender
{
    NSArray* files = [_arrayController arrangedObjects];
    
    NSString* directoryPath = nil;
    
    if( [files count] > 0 ) {
        directoryPath = [[files lastObject] stringByDeletingLastPathComponent];
    }
    else {
        directoryPath = NSHomeDirectory();
    }
    
    NSOpenPanel* openPanel = [NSOpenPanel openPanel];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    [openPanel setDirectoryURL:[NSURL fileURLWithPath:directoryPath]];
    
    [NSApp beginSheet:openPanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:openPanel];
    
    [NSApp endSheet:openPanel];
    [openPanel orderOut:self];
    
    if( ret != NSOKButton )
        return;

    NSArray* URLs = [openPanel URLs];
    [_arrayController addObject:[[URLs objectAtIndex:0] path]];
}

- (IBAction)remove:(id)sender
{
    [_arrayController remove:self];
}

@end
