//
//  AppDelegate.m
//  PDFMerge
//
//  Created by Debenu Pty Ltd on 9/18/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "AppDelegate.h"
#import "Controller.h"

@implementation AppDelegate
@synthesize window;

- (void)dealloc
{
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    
}

- (IBAction)overlay:(id)sender
{
    [self.window makeFirstResponder:nil];
    
    NSFileManager* fileManager = [NSFileManager defaultManager];
    
    NSString* file1 = _field1.stringValue;
    NSString* file2 = _field2.stringValue;
    
    BOOL existFile1 = [fileManager fileExistsAtPath:file1];
    BOOL existFile2 = [fileManager fileExistsAtPath:file2];
    
    if( !existFile1 || !existFile2 ) {
        
        NSAlert* alert = [NSAlert alertWithMessageText:@"Please choose both file."
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@"Combine function requires 2 files"];
        
        [alert runModal];
        return;
    }
    
    Controller* combineController = [[[Controller alloc] init] autorelease];
    
    NSSavePanel* savePanel = [NSSavePanel savePanel];
    [savePanel setNameFieldStringValue:@"overlay"];
    [savePanel setDirectoryURL:[NSURL fileURLWithPath:NSHomeDirectory()]];
    [savePanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    
    [NSApp beginSheet:savePanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:savePanel];
    
    [NSApp endSheet:savePanel];
    [savePanel orderOut:self];
    
    if( ret != NSFileHandlingPanelOKButton )
        return;
    
    NSString* toPath = [[savePanel URL] path];
    
    NSError* error = nil;
    
    if( ![combineController overlayWithFile1:file1 file2:file2 to:toPath error:&error] ) {
        
        NSAlert* alert = [NSAlert alertWithMessageText:@"Error!"
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@"%@", [error localizedDescription]];
        
        [alert runModal];
        return;
    }
    
    [[NSWorkspace sharedWorkspace] openFile:toPath];
}

- (IBAction)choose1:(id)sender
{
    NSOpenPanel* openPanel = [NSOpenPanel openPanel];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    [openPanel setDirectoryURL:[NSURL fileURLWithPath:NSHomeDirectory()]];
    
    [NSApp beginSheet:openPanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:openPanel];
    
    [NSApp endSheet:openPanel];
    [openPanel orderOut:self];
    
    if( ret != NSOKButton )
        return;
    
    NSArray* URLs = [openPanel URLs];
    [_field1 setStringValue:[[URLs objectAtIndex:0] path]];
}

- (IBAction)choose2:(id)sender
{
    NSOpenPanel* openPanel = [NSOpenPanel openPanel];
    [openPanel setAllowsMultipleSelection:NO];
    [openPanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    [openPanel setDirectoryURL:[NSURL fileURLWithPath:NSHomeDirectory()]];
                              
    [NSApp beginSheet:openPanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:openPanel];
    
    [NSApp endSheet:openPanel];
    [openPanel orderOut:self];
    
    if( ret != NSOKButton )
        return;
    
    NSArray* URLs = [openPanel URLs];
    [_field2 setStringValue:[[URLs objectAtIndex:0] path]];
}

@end
