//
//  AppDelegate.m
//  PDFMerge
//
//  Created by Debenu Pty Ltd on 9/18/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "AppDelegate.h"
#import "Controller.h"

@implementation AppDelegate
@synthesize window;

- (void)dealloc
{
    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    
}

- (IBAction)drawShape:(id)sender
{
    [self.window makeFirstResponder:nil];
    
    NSSavePanel* savePanel = [NSSavePanel savePanel];
    [savePanel setNameFieldStringValue:@"Shape"];
    [savePanel setDirectoryURL:[NSURL fileURLWithPath:NSHomeDirectory()]];
    [savePanel setAllowedFileTypes:[NSArray arrayWithObject:@"pdf"]];
    
    [NSApp beginSheet:savePanel
       modalForWindow:self.window
        modalDelegate:nil
       didEndSelector:nil
          contextInfo:NULL];
    
    NSInteger ret = [NSApp runModalForWindow:savePanel];
    
    [NSApp endSheet:savePanel];
    [savePanel orderOut:self];
    
    if( ret != NSFileHandlingPanelOKButton )
        return;
    
    NSString* toPath = [[savePanel URL] path];
    
    NSError* error = nil;

    Controller* controller = [[[Controller alloc] init] autorelease];
    if( ![controller drawShapeToFile:toPath error:&error] ) {

        NSAlert* alert = [NSAlert alertWithMessageText:@"Error!"
                                         defaultButton:@"OK"
                                       alternateButton:nil
                                           otherButton:nil
                             informativeTextWithFormat:@"%@", [error localizedDescription]];

        [alert runModal];
        return;
    }

    [[NSWorkspace sharedWorkspace] openURL:[NSURL fileURLWithPath:toPath]];
}

@end
